import type { SelectNodeFunc, CommonSelectFunc, SiblingSelectFunc, GetDataStringFunc, GetDataFunc, ExpandNode, RefreshFunc } from './types/function';
import type { EnableEdit, DisableEdit, Scale, ToCenter, Install, FocusNode, CancelFocus, InitLeft, InitRight, InitSide, SetLocale } from './types/interact';
/**
 * @function
 * @instance
 * @name selectNode
 * @memberof MapInteraction
 * @description Select a node and add solid border to it.
 * @param {TargetElement} el - Target element return by E('...'), default value: currentTarget.
 */
export declare const selectNode: SelectNodeFunc;
export declare const unselectNode: CommonSelectFunc;
export declare const selectNextSibling: SiblingSelectFunc;
export declare const selectPrevSibling: SiblingSelectFunc;
export declare const selectFirstChild: CommonSelectFunc;
export declare const selectParent: CommonSelectFunc;
/**
 * @function
 * @instance
 * @name getDataString
 * @description Get all node data as string.
 * @memberof MapInteraction
 * @return {string}
 */
export declare const getDataString: GetDataStringFunc;
/**
 * @function
 * @instance
 * @name getData
 * @description Get all node data as object.
 * @memberof MapInteraction
 * @return {Object}
 */
export declare const getData: GetDataFunc;
/**
 * @function
 * @instance
 * @name getDataMd
 * @description Get all node data as markdown.
 * @memberof MapInteraction
 * @return {String}
 */
export declare const getDataMd: GetDataStringFunc;
/**
 * @function
 * @instance
 * @name enableEdit
 * @memberof MapInteraction
 */
export declare const enableEdit: EnableEdit;
/**
 * @function
 * @instance
 * @name disableEdit
 * @memberof MapInteraction
 */
export declare const disableEdit: DisableEdit;
/**
 * @function
 * @instance
 * @name scale
 * @description Change the scale of the mind map.
 * @memberof MapInteraction
 * @param {number}
 */
export declare const scale: Scale;
/**
 * @function
 * @instance
 * @name toCenter
 * @description Reset position of the map to center.
 * @memberof MapInteraction
 */
export declare const toCenter: ToCenter;
/**
 * @function
 * @instance
 * @name install
 * @description Install plugin.
 * @memberof MapInteraction
 */
export declare const install: Install;
/**
 * @function
 * @instance
 * @name focusNode
 * @description Enter focus mode, set the target element as root.
 * @memberof MapInteraction
 * @param {TargetElement} el - Target element return by E('...'), default value: currentTarget.
 */
export declare const focusNode: FocusNode;
/**
 * @function
 * @instance
 * @name cancelFocus
 * @description Exit focus mode.
 * @memberof MapInteraction
 */
export declare const cancelFocus: CancelFocus;
/**
 * @function
 * @instance
 * @name initLeft
 * @description Child nodes will distribute on the left side of the root node.
 * @memberof MapInteraction
 */
export declare const initLeft: InitLeft;
/**
 * @function
 * @instance
 * @name initRight
 * @description Child nodes will distribute on the right side of the root node.
 * @memberof MapInteraction
 */
export declare const initRight: InitRight;
/**
 * @function
 * @instance
 * @name initSide
 * @description Child nodes will distribute on both left and right side of the root node.
 * @memberof MapInteraction
 */
export declare const initSide: InitSide;
/**
 * @function
 * @instance
 * @name setLocale
 * @memberof MapInteraction
 */
export declare const setLocale: SetLocale;
export declare const expandNode: ExpandNode;
/**
 * @function
 * @instance
 * @name refresh
 * @description Refresh mind map, you can use it after modified `this.nodeData`
 * @memberof MapInteraction
 * @param {TargetElement} data mind elixir data
 */
export declare const refresh: RefreshFunc;
