import type { Topic, Wrapper, Parent, Children, CustomSvg } from './dom';
import type { MindElixirInstance, MindElixirData, NodeObj, LinkItem } from './index';
export declare type Init = (this: MindElixirInstance, data: MindElixirData) => void;
export declare type CreateInputDiv = (this: MindElixirInstance, el: Topic) => void;
export declare type CreateWrapper = (this: MindElixirInstance, nodeObj: NodeObj, omitChildren?: boolean) => {
    grp: Wrapper;
    top: Parent;
};
export declare type CreateChildren = (this: MindElixirInstance, wrappers: Wrapper[]) => Children;
export declare type CreateParent = (this: MindElixirInstance, nodeObj: NodeObj) => Parent;
export declare type CreateTopic = (this: MindElixirInstance, nodeObj: NodeObj) => Topic;
export declare type InsertNodeCommon = (this: MindElixirInstance, el?: Topic, node?: NodeObj) => void;
export declare type RemoveNode = (this: MindElixirInstance, el?: Topic) => void;
export declare type MoveNodeCommon = (this: MindElixirInstance, target?: Topic) => void;
export declare type MoveNodeToCommon = (this: MindElixirInstance, from: Topic, to: Topic) => void;
export declare type TNodeCopy = (this: MindElixirInstance, node: Topic, to: Topic) => void;
export declare type AddChildFunction = (this: MindElixirInstance, nodeEle: Topic, node?: NodeObj) => {
    newTop: Parent;
    newNodeObj: NodeObj;
} | null;
export declare type ReshapeNode = (this: MindElixirInstance, tpc: Topic, patchData: NodeObj) => void;
export declare type Layout = (this: MindElixirInstance) => void;
export declare type LayoutChildren = (this: MindElixirInstance, data: NodeObj[], container?: Children, direction?: number) => Children;
export declare type LinkDiv = (this: MindElixirInstance, mainNode?: Wrapper) => void;
export declare type TraverseChildrenFunc = (children: HTMLCollection, parent: Parent, isFirst?: boolean) => string;
export declare type JudgeDirection = (this: MindElixirInstance, mainNode: Wrapper, obj: NodeObj) => void;
export declare type CreateLink = (this: MindElixirInstance, from: Topic, to: Topic, isInitPaint?: boolean, linkObj?: LinkItem) => void;
export declare type RemoveLink = (this: MindElixirInstance, link?: CustomSvg) => void;
export declare type SelectLink = (this: MindElixirInstance, link: CustomSvg) => void;
export declare type LinkControllerData = {
    cx: number;
    cy: number;
    w: any;
    h: any;
};
export declare type ShowLinkController = (this: MindElixirInstance, p2x: number, p2y: number, p3x: number, p3y: number, linkItem: LinkItem, fromData: LinkControllerData, toData: LinkControllerData) => void;
export declare type HideLinkController = (this: MindElixirInstance) => void;
export declare type ExpandNode = (this: MindElixirInstance, el: Topic, isExpand?: boolean) => void;
export declare type SelectNodeFunc = (this: MindElixirInstance, targetElement: Topic, isNewNode?: boolean, e?: MouseEvent) => void;
export declare type CommonSelectFunc = (this: MindElixirInstance) => void;
export declare type SiblingSelectFunc = (this: MindElixirInstance) => boolean;
export declare type GetDataStringFunc = (this: MindElixirInstance) => string;
export declare type GetDataFunc = (this: MindElixirInstance) => MindElixirData;
export declare type RefreshFunc = (this: MindElixirInstance, data?: MindElixirData) => void;
export declare type SetNodeTopic = (this: MindElixirInstance, el: Topic, topic: string) => void;
